'==============================================='
'   REPORT TO RTF
'   EXE CODE
'==============================================='
#Compile Exe
#Dim All
#Optimize Code On
#Optimize Size
#Register None
#Tools Off
#Debug Error On
#Option AnsiApi
'==============================================='
'   ** Version Info **
	#Resource VersionInfo
	#Resource FileFlags 0
	#Resource FileVersion   1, 2, 0, 1
	#Resource StringInfo    "0409", "04B0"
	#Resource Version$  "Comments", "http://glab2007.narod.ru"
	#Resource Version$  "CompanyName",  "GLab2007"
	#Resource Version$  "FileDescription",  "Program to generate RTF report"
	#Resource Version$  "ProductName",  "tRTF.exe"
	#Resource Version$  "LegalCopyright",   "Copyright  2016 by GLab2007"
'==============================================='
'   ** Includes **
'#Include Once "WIN32API.INC"
'==============================================='
'    ** Variables **

'==============================================='
'   ** Macros **
Macro Const = Macro
	Const REP_MARK  = "#"
'==============================================='
'   ** Declarations **
Declare Function ReplaceTextByText Alias "ReplaceTextByText" (ByVal source_text$, ByVal value_row$) As String
Declare Function InsertTableBetweenMasks Alias "InsertTableBetweenMasks" (ByVal source_text$, ByVal mask_id$, ByRef value_rows$()) As String
Declare Function ReplaceMaskByPicture Alias "ReplaceMaskByPicture" (ByVal source_text$, ByVal mask_id$, ByVal pic_path$) As String
Declare Function ReadFileToString (ByVal file_path$) As String
Declare Function WriteStringToFile (ByVal file_path$, ByVal file_text$) As Byte
Declare Function GetHexDump(ByVal file_path$) As String
'==============================================='

'==============================================='
'   ** MAIN APPLICATION ENTRY POINT **
'-----------------------------------------------'
'Generates the file on RTF template & data of DAT
'-----------------------------------------------'
Function PBMain () As Long
'parse command line
Local sDatFile, sTmplFile, sRepFile As String
	If IsNull(Command$) Then
		Exit Function
	End If
	sDatFile = Command$(1)
	If IsNull(sDatFile) Or Not IsFile(sDatFile) Then
		Exit Function
	End If
	sTmplFile = Command$(2)
	If IsNull(sTmplFile) Or Not IsFile(sTmplFile) Then
		Exit Function
	End If
	sRepFile = Command$(3)
	If IsNull(sRepFile) Or Not IsFolder(PathName$(Path, sRepFile)) Then
		Exit Function
	End If
'read template RTF-file in string
Local sRTF As String
	sRTF = ReadFileToString(sTmplFile)
	If IsNull(sRTF) Then
		Exit Function
	End If
'read DAT-file in array
Local s$, count&
	s$ = ReadFileToString(sDatFile)
	If IsNull(s$) Then
		Exit Function
	End If
	count& = ParseCount(s$, $CrLf)
Local aDAT() As String
	ReDim aDAT(1 To count&) As String
	Parse s$, aDAT(), $CrLf
'go on rows of the array
Local i&
Local r&, rows&, arows$()
	For i& = 1 To count&
		s$ = Parse$(aDAT(i&), ":", 1)
		Select Case s$
			Case "", "#"
				Exit Select
			Case "TABLE"
				rows& = Val(Parse$(aDAT(i&), ":", 3))
				If IsFalse(rows&) Then Exit Select
				rows& = Min(rows&, count& - i&) ' if real rows less than writed
				ReDim arows(1 To rows&) As String
				For r& = 1 To rows&
					arows$(r&) = aDAT(i& + r&)
				Next
				s$ = Trim$(Parse$(aDAT(i&), ":", 2))
				If IsNull(s$) Then Exit Select
				sRTF = InsertTableBetweenMasks(sRTF, s$, arows$())
				i& = i& + rows&
			Case "PICTURE"
				s$ = Trim$(Parse$(aDAT(i&), ":", 2))
				If IsNull(s$) Then Exit Select
				sRTF = ReplaceMaskByPicture(sRTF, s$, Parse$(aDAT(i&), ":", 3) & ":" & Parse$(aDAT(i&), ":", 4)) ' plug on c://
			Case Else
				sRTF = ReplaceTextByText(sRTF, aDAT(i&))
		End Select
	Next
'write result RTF report
	i& = WriteStringToFile(sRepFile, sRTF)
End Function
'==============================================='

'==============================================='
'    ** ACTION Functions **
'-----------------------------------------------'

'-----------------------------------------------'
'** Replace a text mask with the new text **
Function ReplaceTextByText Alias "ReplaceTextByText" (ByVal source_text$, ByVal value_row$) As String
On Error GoTo before_exit
Local sMask, aVal() As String
Local s$, i&, count&
	sMask = Parse$(value_row$, ":", 1)
	s$ = Parse$(value_row$, ":", 2)
	If IsNull(s$) Then
		GoTo before_exit
	End If
	count& = ParseCount(s$)
	If count& = 0 Then
		GoTo before_exit
	ElseIf count& = 1 Then
		Replace Build$(REP_MARK, sMask, REP_MARK) With s$ In source_text$
		GoTo before_exit
	End If
	ReDim aVal(1 To count&) As String
	Parse s$, aVal()
	For i& = 1 To count&
		s$ = LTrim$(Str$(i&))
		Replace Build$(REP_MARK, sMask, s$, REP_MARK) With aVal(i&) In source_text$
	Next
before_exit:
	Function = source_text$
End Function
'-----------------------------------------------'
'** Insert the table between masks and replace them **
Function InsertTableBetweenMasks Alias "InsertTableBetweenMasks" (ByVal source_text$, ByVal mask_id$, ByRef value_rows$()) As String
'On Error GoTo before_exit
Local maskstart$, maskend$
	maskstart$ = Build$(REP_MARK, "TABLE", mask_id$, REP_MARK)
	maskend$ = Build$(REP_MARK, mask_id$, "TABLE", REP_MARK)
Local stop&, head&, tail&
'get user table from RTF
Local sTableOld As String
	stop& = InStr(1, source_text$, maskstart$)
	If IsFalse(stop&) Then GoTo before_exit
	head& = InStr(-7, Mid$(source_text$, 1, stop&), "{\rtlch")
	stop& = InStr(1, source_text$, maskend$)
	If IsFalse(stop&) Then GoTo before_exit
	tail& = InStr(1, Mid$(source_text$, stop&, Len(source_text$) - stop&), "}") + stop&
	sTableOld = Mid$(source_text$, head&, tail& - head&)
'get row from user table
Local sTableRow As String
	stop& = InStr(1, sTableOld, maskstart$)
	head& = InStr(-1, Mid$(sTableOld, 1, stop&), "\")
	tail& = InStr(1, Mid$(sTableOld, stop&, Len(sTableRow) - stop&), " \ltrrow") + stop&
	If IsFalse(tail&) Then GoTo before_exit
	sTableRow = Remove$(Mid$(sTableOld, 1, head& - 1), "\par") & Mid$(sTableOld, tail&, Len(sTableOld) - tail&) ' without start mask
	stop& = InStr(1, sTableRow, maskend$)
	head& = InStr(-7, Mid$(sTableRow, 1, stop&), "{\rtlch")
	If IsFalse(head&) Then GoTo before_exit
	sTableRow = Mid$(sTableRow, 1, head& - 1) ' without end mask
'clone table row & replace text
Local sTableNew As String
Local i&
	For i& = 1 To UBound(value_rows$)
		sTableNew = sTableNew & $CrLf & ReplaceTextByText(sTableRow, value_rows$(i&))
	Next
'replace old table in RTF
	Replace sTableOld With sTableNew In source_text$
	If InStr(1, source_text$, maskstart$) > 0 Then
		source_text$ = InsertTableBetweenMasks(source_text$, mask_id$, value_rows$()) ' start of recursion
	End If
before_exit:
	Function = source_text$
End Function
'-----------------------------------------------'
'** Replace a text mask with the picture  **
Function ReplaceMaskByPicture Alias "ReplaceMaskByPicture" (ByVal source_text$, ByVal mask_id$, ByVal pic_path$) As String
On Error GoTo before_exit
Local mask$
	mask$ = Build$(REP_MARK, "PICTURE", mask_id$, REP_MARK)
Local head&, stop&, tail&
Local sHEX As String
	sHEX = GetHexDump(pic_path$)
	If Len(sHEX) = 0 Then GoTo before_exit
	sHEX = "{\*\shppict{\pict\pngblip" & $CrLf & sHEX & $CrLf & "}}}"
	head& = 1 : tail& = 1
	Do
		stop& = InStr(tail&, source_text$, mask$)
		If stop& = 0 Then Exit Do
		tail& = InStr(stop&, source_text$, "}")
		head& = InStr(-1, Mid$(source_text$, 1, stop&), "\")
		source_text$ = Mid$(source_text$, 1, head& - 1) & sHEX & Mid$(source_text$, tail& + 1, Len(source_text$) - tail&)
		tail& = head& + Len(sHEX)
	Loop While stop&
before_exit:
	Function = source_text$
End Function
'==============================================='

'==============================================='
'    ** Inside Function **
'-----------------------------------------------'
'** Read text from the file **
Function ReadFileToString (ByVal file_path$) As String
On Error GoTo before_exit
Local f#, s$
	f# = FreeFile
	Open file_path$ For Binary As #f
	Get$ #f, Lof(#f), s$
	Close #f
before_exit:
	Function = s$
End Function
'-----------------------------------------------'
'** Write text in the file **
Function WriteStringToFile (ByVal file_path$, ByVal file_text$) As Byte
On Error GoTo err_plug
Local f#
	f# = FreeFile
	Open file_path$ For Binary As #f
	Put$ #f, file_text$
	SetEof #f
	Close #f
	Function = 1
err_plug:
End Function
'-----------------------------------------------'
'** Return string with HEX-dump of exists file **
Function GetHexDump(ByVal file_path$) As String
On Error GoTo err_plug
Local sData As String
Local f#
	f# = FreeFile
	Open file_path$ For Binary As #f
	Get$ #f, Lof(#f), sData
	Close #f
	If Len(sData) = 0 Then Exit Function
'build a Table of ALL hex characters...(not just x'00' - x'0F')
Local hexData As String
Local i&
	For i& = 0 To &hFF
		hexData = hexData & Hex$(i&,2)
	Next
'define an array of 2 character strings overlaying our hex characters table
	ReDim hexChar(&hFF) As String * 2 At StrPtr(hexData)
'build an output buffer: 2 hex chars required per input character
Local pSrc As Byte Ptr
Local pDest As String Ptr * 2
Local outBuff As String
	outBuff = Space$(Len(sData) * 2)
	pSrc = StrPtr(sData) ' point to start of input
	pDest = StrPtr (outBuff) ' and output
'for each byte of input move 2 hex characters to output and advance in input & output
	For i& = 1 To Len(sData)
		@pDest = HexChar(@pSrc)
		Incr pSrc
		Incr pDest
	Next
'show the output, should be 512 characters x'FF'- x'00'
	Function = outBuff
err_plug:
End Function
'==============================================='
'Ciril V. Golubev2016 | glab2007@yandex.ru
'http://glab2007.narod.ru
'==============================================='
